(** Count letter frequency of a word *)

(** ASCII code of 'A' letter. *)
let cbase = Char.code 'A'

(**
   Compute a frequency letter table.
   @param string the word to analyse
   @return an array of frequency
*)
let char_freq string = 
  let char_table = Array.make 26 0 in
  String.iter (fun c -> let pos = (Char.code c) - cbase in
			char_table.(pos) <- char_table.(pos) + 1) string;
  char_table
  
(**
   Program main function.
*)
let main () = 
  let string = String.map Char.uppercase (read_line ()) in 
  let cfreq = char_freq string in
  Array.iteri (fun i f -> Printf.printf "%c -> %d\n" (Char.chr (i + cbase)) f) cfreq

(**
   Program entry point.
*)
let _ = main ()
